/**
 * 
 * @author Lorenz Schauer
 * 
 * Programm zum Erzeugen von Threads auf unterschiedliche Arten.
 * Aus Uebung 01 vom 11.01.2016
 *
 */
public class MeineThreads {

	public static void main(String[] args) {
			
		//Threads erzeugen:
		
		//1. Mglichkeit: Erbt von Klasse Thread
		MeinThread t1 = new MeinThread();
		
		//2. Mglichkeit: Implementiert das IFace Runnable und gibt dieses im Konstruktor von Thread mit.
		MeinRunnable runnable = new MeinRunnable();
		Thread t2 = new Thread(runnable);
		
		//3. Mglichkeit: Anonyme innere Klasse von Thread:
		Thread t3 = new Thread(new Runnable() {
			
			@Override
			public void run() {
				for(int i=0; i<200;i++)
					System.out.println(Thread.currentThread().getName()+" schreibt "+i);
			}
		});
		
		//4. Mglichkeit: Lambda-Ausdruck:
		Runnable r = ()->{		
			for(int i=0; i<200;i++)
				System.out.println(Thread.currentThread().getName()+" schreibt "+i);
		};
		// und dem Thread mitteilen
		Thread t4 = new Thread(r);
		
		//Das wuerde eben genau so in einem Schritt gehen (sehr kurz):
		Thread t5 = new Thread(()->{
			for(int i=0; i<200;i++)
				System.out.println(Thread.currentThread().getName()+" schreibt "+i);
		});
		
		
		//Und dann die Threads starten:
		//Man beachte die verzahnte Ausfuehrung!
		
		t1.start();
		t2.start();
		t3.start();
		t4.start();
		t5.start();
	}
	
	
	
}
